package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.shellMode) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public at.ahadev.b4a.ahaActionBar.ahaactionbar _ab = null;
public at.ahadev.b4a.ahaActionBar.ahaactionbar _ab2 = null;
public at.ahadev.b4a.ahaActionBar.ahamenu _menu = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _appicon = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public static int _backcount = 0;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _actionbar1_click(Object _returnvalue) throws Exception{
 //BA.debugLineNum = 109;BA.debugLine="Sub ActionBar1_Click (ReturnValue As Object)";
 //BA.debugLineNum = 110;BA.debugLine="Label1.Text = \"ActionBar1, Clicked: \" & ReturnValue";
mostCurrent._label1.setText((Object)("ActionBar1, Clicked: "+BA.ObjectToString(_returnvalue)));
 //BA.debugLineNum = 111;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_home_click() throws Exception{
 //BA.debugLineNum = 112;BA.debugLine="Sub ActionBar1_Home_Click";
 //BA.debugLineNum = 113;BA.debugLine="Label1.Text = \"ActionBar1, Clicked: Home\"";
mostCurrent._label1.setText((Object)("ActionBar1, Clicked: Home"));
 //BA.debugLineNum = 114;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_menu_closed() throws Exception{
 //BA.debugLineNum = 127;BA.debugLine="Sub ActionBar1_Menu_Closed";
 //BA.debugLineNum = 128;BA.debugLine="Label1.Text = \"ActionBar1, Menu closed\"";
mostCurrent._label1.setText((Object)("ActionBar1, Menu closed"));
 //BA.debugLineNum = 129;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_menu_open() throws Exception{
 //BA.debugLineNum = 124;BA.debugLine="Sub ActionBar1_Menu_Open";
 //BA.debugLineNum = 125;BA.debugLine="Label1.Text = \"ActionBar1, Menu open\"";
mostCurrent._label1.setText((Object)("ActionBar1, Menu open"));
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_navigationdrawer_closed() throws Exception{
 //BA.debugLineNum = 121;BA.debugLine="Sub ActionBar1_NavigationDrawer_Closed";
 //BA.debugLineNum = 122;BA.debugLine="Label1.Text = \"ActionBar1, NavigationDrawer closed\"";
mostCurrent._label1.setText((Object)("ActionBar1, NavigationDrawer closed"));
 //BA.debugLineNum = 123;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_navigationdrawer_move(boolean _opening) throws Exception{
 //BA.debugLineNum = 115;BA.debugLine="Sub ActionBar1_NavigationDrawer_Move(Opening As Boolean)";
 //BA.debugLineNum = 116;BA.debugLine="Label1.Text = \"ActionBar1, NavigationDrawer moving...\"";
mostCurrent._label1.setText((Object)("ActionBar1, NavigationDrawer moving..."));
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return "";
}
public static String  _actionbar1_navigationdrawer_open() throws Exception{
 //BA.debugLineNum = 118;BA.debugLine="Sub ActionBar1_NavigationDrawer_Open";
 //BA.debugLineNum = 119;BA.debugLine="Label1.Text = \"ActionBar1, NavigationDrawer open\"";
mostCurrent._label1.setText((Object)("ActionBar1, NavigationDrawer open"));
 //BA.debugLineNum = 120;BA.debugLine="End Sub";
return "";
}
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.drawable.GradientDrawable _gd = null;
int[] _clrs = null;
int _i = 0;
 //BA.debugLineNum = 34;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 36;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 //BA.debugLineNum = 39;BA.debugLine="bmp.Initialize(File.DirAssets,\"achievements.png\")";
mostCurrent._bmp.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"achievements.png");
 //BA.debugLineNum = 40;BA.debugLine="AppIcon.Initialize(File.DirAssets,\"icon.png\")";
mostCurrent._appicon.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"icon.png");
 //BA.debugLineNum = 43;BA.debugLine="AB2.Initialize(Activity,Panel1,Me,\"ActionBar2\")";
mostCurrent._ab2._initialize(mostCurrent.activityBA,mostCurrent._activity,mostCurrent._panel1,main.getObject(),"ActionBar2");
 //BA.debugLineNum = 44;BA.debugLine="AB2.ABIcon = AppIcon";
mostCurrent._ab2._setvvvvvvvvvvvvvv1(mostCurrent._appicon);
 //BA.debugLineNum = 45;BA.debugLine="AB2.DarkTheme = True";
mostCurrent._ab2._setvvvvvvvvvvvvvvv3(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 46;BA.debugLine="AB2.AbTitle  = \"ActionBar\"";
mostCurrent._ab2._setvvvvvvvvvvvvvv5("ActionBar");
 //BA.debugLineNum = 47;BA.debugLine="AB2.AbSubTitle = \"TEST\"";
mostCurrent._ab2._setvvvvvvvvvvvvvv2("TEST");
 //BA.debugLineNum = 48;BA.debugLine="AB2.MenuUseSymbols = False";
mostCurrent._ab2._setvvvvvvvvvvvvvvv0(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 49;BA.debugLine="AB2.MenuTextColor = Colors.Red";
mostCurrent._ab2._setvvvvvvvvvvvvvvv6(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 50;BA.debugLine="AB2.MenuTextSize = 22";
mostCurrent._ab2._setvvvvvvvvvvvvvvv7((int) (22));
 //BA.debugLineNum = 51;BA.debugLine="AB2.MenuAnimationDuration = 500";
mostCurrent._ab2._setvvvvvvvvvvvvvvv4((int) (500));
 //BA.debugLineNum = 52;BA.debugLine="AB2.ArrowUp = True";
mostCurrent._ab2._setvvvvvvvvvvvvvvv1(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 54;BA.debugLine="Dim gd As GradientDrawable";
_gd = new anywheresoftware.b4a.objects.drawable.GradientDrawable();
 //BA.debugLineNum = 55;BA.debugLine="Dim Clrs(3) As Int";
_clrs = new int[(int) (3)];
;
 //BA.debugLineNum = 56;BA.debugLine="Clrs(0) = Colors.Black";
_clrs[(int) (0)] = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 57;BA.debugLine="Clrs(1) = Colors.DarkGray";
_clrs[(int) (1)] = anywheresoftware.b4a.keywords.Common.Colors.DarkGray;
 //BA.debugLineNum = 58;BA.debugLine="Clrs(2) = Colors.Black";
_clrs[(int) (2)] = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 59;BA.debugLine="gd.Initialize(\"TOP_BOTTOM\",Clrs)";
_gd.Initialize(BA.getEnumFromString(android.graphics.drawable.GradientDrawable.Orientation.class,"TOP_BOTTOM"),_clrs);
 //BA.debugLineNum = 61;BA.debugLine="AB2.ABPanel.Background = gd";
mostCurrent._ab2._v5().setBackground((android.graphics.drawable.Drawable)(_gd.getObject()));
 //BA.debugLineNum = 62;BA.debugLine="AB2.menu.MenuListView.Background = gd";
mostCurrent._ab2._vvvvvvvvvvvvvvvvvvvvvvvvv7._vvvvvvvvvvvvvvvvvvvvvvvvvv6().setBackground((android.graphics.drawable.Drawable)(_gd.getObject()));
 //BA.debugLineNum = 66;BA.debugLine="AB.Initialize(Activity,Null   ,Me,\"ActionBar1\")";
mostCurrent._ab._initialize(mostCurrent.activityBA,mostCurrent._activity,(anywheresoftware.b4a.objects.PanelWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.PanelWrapper(), (android.view.ViewGroup)(anywheresoftware.b4a.keywords.Common.Null)),main.getObject(),"ActionBar1");
 //BA.debugLineNum = 69;BA.debugLine="If 100%y >= 100%x Then 'Portrait";
if (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)>=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 70;BA.debugLine="AB.ABHeight = 48dip";
mostCurrent._ab._setvvvvvvvvvvvvv0(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (48)));
 }else {
 //BA.debugLineNum = 72;BA.debugLine="AB.ABHeight = 40dip";
mostCurrent._ab._setvvvvvvvvvvvvv0(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)));
 };
 //BA.debugLineNum = 75;BA.debugLine="AB.ABIcon = AppIcon";
mostCurrent._ab._setvvvvvvvvvvvvvv1(mostCurrent._appicon);
 //BA.debugLineNum = 76;BA.debugLine="AB.AbTitle  = \"aActionBarExample\"";
mostCurrent._ab._setvvvvvvvvvvvvvv5("aActionBarExample");
 //BA.debugLineNum = 83;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 84;BA.debugLine="For i = 0 To 3";
{
final int step42 = 1;
final int limit42 = (int) (3);
for (_i = (int) (0); (step42 > 0 && _i <= limit42) || (step42 < 0 && _i >= limit42); _i = ((int)(0 + _i + step42))) {
 //BA.debugLineNum = 85;BA.debugLine="AB.AddActionButton(\"ActionButton #\"& i,bmp, \"ActionButton #\" & i)";
mostCurrent._ab._v6("ActionButton #"+BA.NumberToString(_i),mostCurrent._bmp,(Object)("ActionButton #"+BA.NumberToString(_i)));
 //BA.debugLineNum = 86;BA.debugLine="AB2.AddActionButton(\"ActionButton #\"& i,bmp, \"ActionButton #\" & i)";
mostCurrent._ab2._v6("ActionButton #"+BA.NumberToString(_i),mostCurrent._bmp,(Object)("ActionButton #"+BA.NumberToString(_i)));
 }
};
 //BA.debugLineNum = 89;BA.debugLine="For  i = 0 To 4";
{
final int step46 = 1;
final int limit46 = (int) (4);
for (_i = (int) (0); (step46 > 0 && _i <= limit46) || (step46 < 0 && _i >= limit46); _i = ((int)(0 + _i + step46))) {
 //BA.debugLineNum = 90;BA.debugLine="AB.AddMenuItem(\"Menu #\" & i,bmp ,\"Menu #\" & i)";
mostCurrent._ab._v7("Menu #"+BA.NumberToString(_i),mostCurrent._bmp,(Object)("Menu #"+BA.NumberToString(_i)));
 //BA.debugLineNum = 91;BA.debugLine="AB2.AddMenuItem(\"Menu #\" & i,bmp ,\"Menu #\" & i)";
mostCurrent._ab2._v7("Menu #"+BA.NumberToString(_i),mostCurrent._bmp,(Object)("Menu #"+BA.NumberToString(_i)));
 }
};
 //BA.debugLineNum = 93;BA.debugLine="For i = 0 To 6";
{
final int step50 = 1;
final int limit50 = (int) (6);
for (_i = (int) (0); (step50 > 0 && _i <= limit50) || (step50 < 0 && _i >= limit50); _i = ((int)(0 + _i + step50))) {
 //BA.debugLineNum = 94;BA.debugLine="AB.AddNavigationDrawerItem(\"NDrawer #\" & i,bmp,\"NDrawer\" & i)";
mostCurrent._ab._v0("NDrawer #"+BA.NumberToString(_i),mostCurrent._bmp,(Object)("NDrawer"+BA.NumberToString(_i)));
 }
};
 //BA.debugLineNum = 99;BA.debugLine="menu.Initialize(Activity,Me,\"Menu\",Button1.Left,Button1.Top)";
mostCurrent._menu._initialize(mostCurrent.activityBA,mostCurrent._activity,main.getObject(),"Menu",mostCurrent._button1.getLeft(),mostCurrent._button1.getTop());
 //BA.debugLineNum = 100;BA.debugLine="menu.AddMenuItem(\"Test\",Null,\"1\")";
mostCurrent._menu._v7("Test",(anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper(), (android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null)),(Object)("1"));
 //BA.debugLineNum = 101;BA.debugLine="For i = 1 To 5";
{
final int step55 = 1;
final int limit55 = (int) (5);
for (_i = (int) (1); (step55 > 0 && _i <= limit55) || (step55 < 0 && _i >= limit55); _i = ((int)(0 + _i + step55))) {
 //BA.debugLineNum = 102;BA.debugLine="menu.AddMenuItem(\"Test\" & i,bmp,i)";
mostCurrent._menu._v7("Test"+BA.NumberToString(_i),mostCurrent._bmp,(Object)(_i));
 }
};
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 139;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event";
 //BA.debugLineNum = 141;BA.debugLine="If menu.isVisible Then";
if (mostCurrent._menu._vvvvvvvvvvvvvvvvvvvvvvvvvv5()) { 
 //BA.debugLineNum = 142;BA.debugLine="Return menu.Keypress(KeyCode)";
if (true) return mostCurrent._menu._vvvvvvv3(_keycode);
 }else if(mostCurrent._ab._vvvvvvv5() || mostCurrent._ab._vvvvvvv4()) { 
 //BA.debugLineNum = 144;BA.debugLine="Return AB.Keypress(KeyCode)";
if (true) return mostCurrent._ab._vvvvvvv3(_keycode);
 }else if(mostCurrent._ab2._vvvvvvv5() || mostCurrent._ab2._vvvvvvv4()) { 
 //BA.debugLineNum = 146;BA.debugLine="Return AB2.Keypress(KeyCode)";
if (true) return mostCurrent._ab2._vvvvvvv3(_keycode);
 };
 //BA.debugLineNum = 149;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 //BA.debugLineNum = 150;BA.debugLine="BackCount = BackCount +1";
_backcount = (int) (_backcount+1);
 }else {
 //BA.debugLineNum = 152;BA.debugLine="BackCount = 0";
_backcount = (int) (0);
 };
 //BA.debugLineNum = 155;BA.debugLine="If BackCount = 1 Then";
if (_backcount==1) { 
 //BA.debugLineNum = 156;BA.debugLine="ToastMessageShow(\"Next back closes app..\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Next back closes app..",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 157;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 160;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 136;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 138;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 132;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 134;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
 //BA.debugLineNum = 165;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 166;BA.debugLine="menu.OpenMenu";
mostCurrent._menu._vvvvvvvvvvvvvvvvvvvvvvvvvv7();
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim AB,AB2 As ahaActionBar";
mostCurrent._ab = new at.ahadev.b4a.ahaActionBar.ahaactionbar();
mostCurrent._ab2 = new at.ahadev.b4a.ahaActionBar.ahaactionbar();
 //BA.debugLineNum = 24;BA.debugLine="Dim menu As ahaMenu";
mostCurrent._menu = new at.ahadev.b4a.ahaActionBar.ahamenu();
 //BA.debugLineNum = 26;BA.debugLine="Dim Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim bmp, AppIcon As Bitmap";
mostCurrent._bmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
mostCurrent._appicon = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim Label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Private BackCount As Int = 0";
_backcount = (int) (0);
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _menu_click(Object _returnvalue) throws Exception{
 //BA.debugLineNum = 162;BA.debugLine="Sub Menu_Click(ReturnValue As Object)";
 //BA.debugLineNum = 163;BA.debugLine="ToastMessageShow(\"Menuitem #\" & ReturnValue & \" clicked!\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Menuitem #"+BA.ObjectToString(_returnvalue)+" clicked!",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 164;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
